/// <reference types="node" />
import os from './os';
import watch from './watch';
declare const $: {
    argv: <T = {}>() => T & {
        [x: string]: unknown;
        _: (string | number)[];
        $0: string;
    };
    backup: (source: string | string[]) => Promise<void>;
    clean: (source: string | string[]) => Promise<void>;
    compile: {
        (source: string | string[], Option?: Partial<{
            bare: boolean;
            base: string;
            minify: boolean;
            sourcemaps: boolean;
        }> | undefined): Promise<void>;
        (source: string | string[], target: string, option?: Partial<{
            bare: boolean;
            base: string;
            minify: boolean;
            sourcemaps: boolean;
        }> | undefined): Promise<void>;
    };
    copy: (source: string | string[], target: string, option?: string | {
        dirname?: string | undefined;
        basename?: string | undefined;
        extname?: string | undefined;
        prefix?: string | undefined;
        suffix?: string | undefined;
    } | undefined) => Promise<void>;
    download: (source: string, target: string, option?: string | Partial<import("./download").Option>) => Promise<void>;
    exec: (cmd: string | string[], option?: {
        ignoreError?: boolean | undefined;
        silent?: boolean | undefined;
    }) => Promise<[boolean, string]>;
    formatArgument: {
        (input: boolean): boolean[];
        (input: number): number[];
        (input: string | string[]): string[];
        (input: unknown): unknown[];
    };
    getBasename: (input: string) => string;
    getDirname: (input: string) => string;
    getExtname: (input: string) => string;
    getFilename: (input: string) => string;
    getName: (input: string) => {
        basename: string;
        dirname: string;
        extname: string;
        filename: string;
    };
    home: () => string;
    i: <T_1>(input: T_1) => T_1;
    info: {
        (): import("./info").M;
        <T_2>(input: T_2): T_2;
        <T_3>(type: string, input: T_3): T_3;
    };
    isExisted: (source: string | string[]) => Promise<boolean>;
    isSame: (source: string | string[]) => Promise<boolean>;
    link: (source: string, target: string) => Promise<void>;
    mkdir: (source: string | string[]) => Promise<void>;
    move: (source: string | string[], target: string, option?: string | {
        dirname?: string | undefined;
        basename?: string | undefined;
        extname?: string | undefined;
        prefix?: string | undefined;
        suffix?: string | undefined;
    } | undefined) => Promise<void>;
    normalizePath: (source: string) => string;
    normalizePathToArray: (source: string | string[]) => string[];
    os: typeof os;
    parseJson: {
        <T_4>(input: unknown): T_4;
        (input: unknown): unknown[] | {
            [key: string]: unknown;
        };
    };
    parseString: (input: unknown) => string;
    prompt: {
        (option: {
            default?: boolean | undefined;
            id?: string | undefined;
            message?: string | undefined;
            type: "confirm";
        }): Promise<boolean>;
        (option: {
            default?: number | undefined;
            id?: string | undefined;
            max?: number | undefined;
            message?: string | undefined;
            min?: number | undefined;
            type: "number";
        }): Promise<number>;
        (option: {
            default?: string | undefined;
            id?: string | undefined;
            message?: string | undefined;
            type: "text";
        }): Promise<string>;
        (option: {
            default?: string | boolean | undefined;
            id?: string | undefined;
            message?: string | undefined;
            off?: string | undefined;
            on?: string | undefined;
            type: "toggle";
        }): Promise<boolean>;
        <T_5 = string>(option: {
            default?: string | number | undefined;
            id?: string | undefined;
            list: {
                title: string;
                value: T_5;
            }[] | T_5[];
            message?: string | undefined;
            type: "auto" | "select" | "multiselect" | "autocomplete" | "multi";
        }): Promise<T_5>;
    };
    read: <U = undefined, T_6 extends string = string>(source: T_6, option?: {
        raw: boolean;
    } | undefined) => Promise<U extends undefined ? (T_6 extends `${string}.coffee` | `${string}.css` | `${string}.html` | `${string}.js` | `${string}.md` | `${string}.pug` | `${string}.styl` | `${string}.ts` | `${string}.ahk` | `${string}.bat` | `${string}.sh` | `${string}.tsx` | `${string}.txt` | `${string}.xml` ? string : T_6 extends `${string}.yaml` | `${string}.json` | `${string}.yml` ? {
        [x: string]: unknown;
    } : Buffer) | undefined : U>;
    recover: (source: string | string[]) => Promise<void>;
    remove: (source: string | string[]) => Promise<void>;
    rename: (source: string | string[], option: string | {
        dirname?: string | undefined;
        basename?: string | undefined;
        extname?: string | undefined;
        prefix?: string | undefined;
        suffix?: string | undefined;
    }) => Promise<void>;
    root: () => string;
    say: (text: string, option?: {
        lang?: "ja" | "ja-jp" | "zh" | "zh-cn" | "zh-hk" | "zh-tw" | undefined;
        voice?: "kyoko" | "ting-ting" | "sin-ji" | "mei-jia" | undefined;
    }) => Promise<void>;
    sleep: (delay?: number) => Promise<void>;
    source: (source: string | string[] | (string[] & {
        __is_listed_as_source__?: boolean | undefined;
    })) => Promise<string[]>;
    stat: (source: string) => Promise<import("fs").Stats | null>;
    type: (input: unknown) => string;
    watch: typeof watch;
    wrapList: (input: unknown) => string;
    write: (source: string, content: unknown, option?: string | {
        encoding?: string | null | undefined;
        flag?: string | undefined;
        mode?: number | undefined;
    } | undefined) => Promise<boolean>;
    zip: (source: string | string[], target?: string, option?: string | {
        base?: string | undefined;
        filename?: string | undefined;
    }) => Promise<void>;
};
export default $;
