"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.M = void 0;
var home_1 = __importDefault(require("./home"));
var i_1 = __importDefault(require("./i"));
var parseString_1 = __importDefault(require("./parseString"));
var root_1 = __importDefault(require("./root"));
var kleur_1 = __importDefault(require("kleur"));
var M = (function () {
    function M() {
        this.cacheTime = [0, ''];
        this.cacheType = {
            default: '',
        };
        this.isFrozen = false;
        this.isSilent = false;
        this.regHome = new RegExp("^" + home_1.default().replace(/\\/g, '\\\\'), 'g');
        this.regRoot = new RegExp("^" + root_1.default().replace(/\\/g, '\\\\'), 'g');
        this.separator = kleur_1.default.gray('›') + " ";
    }
    M.prototype.execute = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!args.length)
            return this;
        var _a = args.length > 1
            ? args
            : ['default', args[0]], type = _a[0], message = _a[1];
        if (this.isSilent)
            return message;
        var msg = parseString_1.default(message)
            .trim();
        if (!msg)
            return message;
        i_1.default(this.render(type, msg));
        return message;
    };
    M.prototype.freeze = function (fn) {
        return __awaiter(this, void 0, void 0, function () {
            var result, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        Object.assign(this, {
                            isFrozen: true,
                            isSilent: true,
                        });
                        if (!(typeof fn === 'function')) return [3, 2];
                        return [4, fn()];
                    case 1:
                        _a = _b.sent();
                        return [3, 4];
                    case 2: return [4, fn];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4:
                        result = _a;
                        Object.assign(this, {
                            isFrozen: false,
                            isSilent: false,
                        });
                        return [2, result];
                }
            });
        });
    };
    M.makeTextOfTime = function () {
        var date = new Date();
        var listTime = [
            date.getHours(),
            date.getMinutes(),
            date.getSeconds(),
        ];
        return listTime
            .map(function (it) { return it.toString().padStart(2, '0'); })
            .join(':');
    };
    M.prototype.pause = function () {
        if (this.isFrozen)
            return;
        this.isSilent = true;
    };
    M.prototype.render = function (type, message) {
        return [
            this.renderTime(),
            this.separator,
            this.renderType(type),
            this.renderContent(message),
        ].join('');
    };
    M.prototype.renderContent = function (message) {
        return this.renderPath(message)
            .replace(/'.*?'/g, function (text) {
            var cont = text.replace(/'/g, '');
            return cont
                ? kleur_1.default.magenta(cont)
                : "''";
        });
    };
    M.prototype.renderPath = function (message) {
        return message
            .replace(this.regRoot, '.')
            .replace(this.regHome, '~');
    };
    M.prototype.renderTime = function () {
        var cache = this.cacheTime;
        var ts = Math.floor(new Date().getTime() / 1e3);
        if (ts === cache[0])
            return cache[1];
        cache[0] = ts;
        cache[1] = kleur_1.default.gray("[" + M.makeTextOfTime() + "]") + " ";
        return cache[1];
    };
    M.prototype.renderType = function (type) {
        var cache = this.cacheType;
        var _type = type
            .trim()
            .toLowerCase();
        if (typeof cache[_type] === 'string')
            return cache[_type];
        var content = kleur_1.default.cyan().underline(_type);
        var padding = ' '.repeat(Math.max(10 - _type.length, 0));
        cache[_type] = "" + content + padding;
        return cache[_type];
    };
    M.prototype.resume = function () {
        if (this.isFrozen)
            return;
        this.isSilent = false;
    };
    M.prototype.whisper_ = function (fn) {
        return __awaiter(this, void 0, void 0, function () {
            var result, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.pause();
                        if (!(typeof fn === 'function')) return [3, 2];
                        return [4, fn()];
                    case 1:
                        _a = _b.sent();
                        return [3, 4];
                    case 2: return [4, fn];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4:
                        result = _a;
                        this.resume();
                        return [2, result];
                }
            });
        });
    };
    return M;
}());
exports.M = M;
var m = new M();
exports.default = m.execute.bind(m);
