"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var info_1 = __importDefault(require("./info"));
var normalizePathToArray_1 = __importDefault(require("./normalizePathToArray"));
var parseString_1 = __importDefault(require("./parseString"));
var read_1 = __importDefault(require("./read"));
var stat_1 = __importDefault(require("./stat"));
var main = function (source) { return __awaiter(void 0, void 0, void 0, function () {
    var listSource, cacheSize, _i, listSource_1, src, stat, size, cacheCont, _loop_1, _a, listSource_2, src, state_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                listSource = normalizePathToArray_1.default(source);
                if (listSource.length < 2)
                    return [2, false];
                cacheSize = 0;
                _i = 0, listSource_1 = listSource;
                _b.label = 1;
            case 1:
                if (!(_i < listSource_1.length)) return [3, 4];
                src = listSource_1[_i];
                return [4, stat_1.default(src)];
            case 2:
                stat = _b.sent();
                if (!stat)
                    return [2, false];
                size = stat.size;
                if (!cacheSize) {
                    cacheSize = size;
                    return [3, 3];
                }
                if (size !== cacheSize)
                    return [2, false];
                _b.label = 3;
            case 3:
                _i++;
                return [3, 1];
            case 4:
                cacheCont = '';
                _loop_1 = function (src) {
                    var cont;
                    return __generator(this, function (_c) {
                        switch (_c.label) {
                            case 0: return [4, info_1.default().whisper_(function () { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4, read_1.default(src)];
                                        case 1: return [2, _a.sent()];
                                    }
                                }); }); })];
                            case 1:
                                cont = _c.sent();
                                if (!cont)
                                    return [2, { value: false }];
                                cont = parseString_1.default(cont);
                                if (!cacheCont) {
                                    cacheCont = cont;
                                    return [2, "continue"];
                                }
                                if (cont !== cacheCont)
                                    return [2, { value: false }];
                                return [2];
                        }
                    });
                };
                _a = 0, listSource_2 = listSource;
                _b.label = 5;
            case 5:
                if (!(_a < listSource_2.length)) return [3, 8];
                src = listSource_2[_a];
                return [5, _loop_1(src)];
            case 6:
                state_1 = _b.sent();
                if (typeof state_1 === "object")
                    return [2, state_1.value];
                _b.label = 7;
            case 7:
                _a++;
                return [3, 5];
            case 8: return [2, true];
        }
    });
}); };
exports.default = main;
