"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var home_1 = __importDefault(require("./home"));
var path_1 = __importDefault(require("path"));
var root_1 = __importDefault(require("./root"));
var trimEnd_1 = __importDefault(require("lodash/trimEnd"));
var main = function (source) {
    if (typeof source !== 'string')
        return '';
    if (!source)
        return '';
    var isIgnored = source[0] === '!';
    var _source = isIgnored
        ? source.slice(1)
        : source;
    _source = _source.replace(/\.{2}/g, '__parent_directory__');
    if (_source[0] === '.')
        _source = _source.replace(/\./u, root_1.default());
    else if (_source[0] === '~')
        _source = _source.replace(/~/u, home_1.default());
    _source = _source.replace(/__parent_directory__/g, '..');
    if (_source.startsWith('..'))
        _source = root_1.default() + "/" + _source;
    _source = path_1.default.normalize(_source)
        .replace(/\\/g, '/');
    if (!path_1.default.isAbsolute(_source))
        _source = root_1.default() + "/" + _source;
    if (isIgnored)
        _source = "!" + _source;
    return trimEnd_1.default(_source, '/');
};
exports.default = main;
