declare type Choice<T = Value> = {
    title: string;
    value: T;
};
declare type Main = {
    (option: OptionConfirm): Promise<boolean>;
    (option: OptionNumber): Promise<number>;
    (option: OptionText): Promise<string>;
    (option: OptionToggle): Promise<boolean>;
    <T = string>(option: OptionSelect<T>): Promise<T>;
};
declare type Option = OptionConfirm | OptionNumber | OptionText | OptionToggle | OptionSelect;
declare type OptionConfirm = {
    default?: boolean;
    id?: string;
    message?: string;
    type: 'confirm';
};
declare type OptionNumber = {
    default?: number;
    id?: string;
    max?: number;
    message?: string;
    min?: number;
    type: 'number';
};
declare type OptionSelect<T = string> = {
    default?: number | string;
    id?: string;
    list: Choice<T>[] | T[];
    message?: string;
    type: 'auto' | 'autocomplete' | 'multi' | 'multiselect' | 'select';
};
declare type OptionText = {
    default?: string;
    id?: string;
    message?: string;
    type: 'text';
};
declare type OptionToggle = {
    default?: boolean | string;
    id?: string;
    message?: string;
    off?: string;
    on?: string;
    type: 'toggle';
};
declare type Value = Option['default'];
declare const main: Main;
export default main;
