"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var info_1 = __importDefault(require("./info"));
var parseString_1 = __importDefault(require("./parseString"));
var read_1 = __importDefault(require("./read"));
var type_1 = __importDefault(require("./type"));
var write_1 = __importDefault(require("./write"));
var findIndex_1 = __importDefault(require("lodash/findIndex"));
var get_1 = __importDefault(require("lodash/get"));
var prompts_1 = __importDefault(require("prompts"));
var listTypePrompt = [
    'autocomplete',
    'confirm',
    'multiselect',
    'number',
    'select',
    'text',
    'toggle',
];
var listType = __spreadArray(__spreadArray([], listTypePrompt), [
    'auto',
    'multi',
]);
var listTypeCache = [
    'autocomplete',
    'confirm',
    'number',
    'select',
    'text',
    'toggle',
];
var mapMessage = {
    autocomplete: 'input',
    confirm: 'confirm',
    multiselect: 'select',
    number: 'input number',
    select: 'select',
    text: 'input text',
    toggle: 'toggle',
};
var pathCache = './temp/cache-prompt.json';
var formatOption = function (option) { return __awaiter(void 0, void 0, void 0, function () {
    var opt, _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                opt = __assign({ active: 'on', choices: [], inactive: 'off', initial: undefined, name: '' }, option);
                if (opt.type === 'auto')
                    opt.type = 'autocomplete';
                if (opt.type === 'multi')
                    opt.type = 'multiselect';
                if (!listTypePrompt.includes(opt.type))
                    throw new Error("prompt_/error: invalid type '" + opt.type + "'");
                if (!opt.message)
                    opt.message = mapMessage[opt.type];
                if (!opt.name)
                    opt.name = 'value';
                if (validateAsSelect(opt)) {
                    if (!opt.list)
                        throw new Error('prompt_/error: empty list');
                    opt.choices = __spreadArray([], opt.list).map(function (it) { return validateAsChoice(it)
                        ? it
                        : {
                            title: parseString_1.default(it),
                            value: it,
                        }; });
                    opt.initial = typeof opt.default === 'number'
                        ? (function () {
                            var result = opt.default >= 0
                                ? opt.default
                                : opt.list.length + opt.default;
                            if (result < 0)
                                result = 0;
                            if (result >= opt.list.length)
                                result = opt.list.length - 1;
                            return result;
                        })()
                        : findIndex_1.default(opt.choices, function (it) { return opt.default === it.value; });
                    opt.list = [];
                }
                if (opt.type === 'toggle') {
                    if (opt.on)
                        opt.active = opt.on;
                    if (opt.off)
                        opt.inactive = opt.off;
                    opt.initial = opt.default === opt.on;
                    opt.on = undefined;
                    opt.off = undefined;
                }
                if (!(opt.initial === undefined || opt.initial === null)) return [3, 3];
                _a = opt;
                _b = opt.default;
                if (_b) return [3, 2];
                return [4, getCache(opt)];
            case 1:
                _b = (_c.sent());
                _c.label = 2;
            case 2:
                _a.initial = _b;
                _c.label = 3;
            case 3:
                opt.default = undefined;
                return [2, opt];
        }
    });
}); };
var getCache = function (option) { return __awaiter(void 0, void 0, void 0, function () {
    var cache, item, type, value, index;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!option.id)
                    return [2, undefined];
                if (!listTypeCache.includes(option.type))
                    return [2, undefined];
                return [4, read_1.default(pathCache)];
            case 1:
                cache = _a.sent();
                item = get_1.default(cache, option.id);
                if (!item)
                    return [2, undefined];
                type = item.type, value = item.value;
                if (type !== option.type)
                    return [2, undefined];
                if (type === 'select') {
                    index = findIndex_1.default(option.choices, { value: value });
                    return [2, ~index
                            ? index
                            : undefined];
                }
                return [2, value];
        }
    });
}); };
var main = function (option) { return __awaiter(void 0, void 0, void 0, function () {
    var opt, result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (!option)
                    throw new Error('prompt_/error: empty option');
                info_1.default().pause();
                return [4, formatOption(option)];
            case 1:
                opt = _a.sent();
                return [4, prompts_1.default(opt)];
            case 2:
                result = (_a.sent())[opt.name];
                return [4, setCache(opt, result)];
            case 3:
                _a.sent();
                info_1.default().resume();
                return [2, result];
        }
    });
}); };
var setCache = function (option, value) { return __awaiter(void 0, void 0, void 0, function () {
    var id, type, cache;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                id = option.id, type = option.type;
                if (!id)
                    return [2];
                return [4, read_1.default(pathCache)];
            case 1:
                cache = (_a.sent()) || {};
                cache[id] = { type: type, value: value };
                return [4, write_1.default(pathCache, cache)];
            case 2:
                _a.sent();
                return [2];
        }
    });
}); };
var validateAsChoice = function (input) { return type_1.default(input) === 'object'; };
var validateAsSelect = function (option) { return ['autocomplete', 'multiselect', 'select'].includes(option.type); };
exports.default = main;
