"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var getBasename_1 = __importDefault(require("./getBasename"));
var getDirname_1 = __importDefault(require("./getDirname"));
var info_1 = __importDefault(require("./info"));
var normalizePath_1 = __importDefault(require("./normalizePath"));
var normalizePathToArray_1 = __importDefault(require("./normalizePathToArray"));
var source_1 = __importDefault(require("./source"));
var wrapList_1 = __importDefault(require("./wrapList"));
var trim_1 = __importDefault(require("lodash/trim"));
var archiver_1 = __importDefault(require("archiver"));
var fs_1 = __importDefault(require("fs"));
var kleur_1 = __importDefault(require("kleur"));
var ora_1 = __importDefault(require("ora"));
var execute = function (listSource, target, option) { return __awaiter(void 0, void 0, void 0, function () {
    var base, filename, spinner, listResource;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                base = option.base, filename = option.filename;
                spinner = ora_1.default().start();
                return [4, source_1.default(listSource)];
            case 1:
                listResource = _a.sent();
                return [4, new Promise(function (resolve) {
                        var output = fs_1.default.createWriteStream(target + "/" + filename);
                        var archive = archiver_1.default('zip', {
                            zlib: {
                                level: 9,
                            },
                        });
                        var message = '';
                        archive.on('end', function () {
                            spinner.succeed();
                            resolve(true);
                        });
                        archive.on('entry', function (e) {
                            message = info_1.default().renderPath("" + e.name);
                        });
                        archive.on('error', function (e) {
                            spinner.fail(e.message);
                            throw e;
                        });
                        archive.on('progress', function (e) {
                            if (!message)
                                return;
                            var gray = kleur_1.default.gray(Math.round(e.fs.processedBytes * 100 / e.fs.totalBytes) + "%");
                            var magenta = kleur_1.default.magenta(message);
                            spinner.text = gray + " " + magenta;
                            message = '';
                        });
                        archive.on('warning', function (e) {
                            spinner.warn(e.message);
                            throw (e);
                        });
                        archive.pipe(output);
                        for (var _i = 0, listResource_1 = listResource; _i < listResource_1.length; _i++) {
                            var src = listResource_1[_i];
                            var name_1 = src.replace(base, '');
                            archive.file(src, { name: name_1 });
                        }
                        archive.finalize();
                    })];
            case 2:
                _a.sent();
                return [2];
        }
    });
}); };
var formatArgument = function (source, target, option) {
    var listSource = normalizePathToArray_1.default(source);
    var pathTarget = normalizePath_1.default(target || getDirname_1.default(listSource[0]).replace(/\*/g, ''));
    var _a = typeof option === 'string'
        ? ['', option]
        : [
            option.base || '',
            option.filename || '',
        ], base = _a[0], filename = _a[1];
    base = normalizePath_1.default(base || getBase(listSource));
    if (!filename)
        filename = getBasename_1.default(pathTarget) + ".zip";
    return [
        listSource,
        pathTarget,
        {
            base: base,
            filename: filename,
        },
    ];
};
var getBase = function (listSource) {
    var source = listSource[0];
    if (source.includes('*'))
        return trim_1.default(source.replace(/\*.*/u, ''), '/');
    return getDirname_1.default(source);
};
var main = function (source, target, option) {
    if (target === void 0) { target = ''; }
    if (option === void 0) { option = ''; }
    return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, execute.apply(void 0, formatArgument(source, target, option))];
                case 1:
                    _a.sent();
                    info_1.default('zip', "zipped " + wrapList_1.default(source) + " to '" + target + "', as '" + option.toString() + "'");
                    return [2];
            }
        });
    });
};
exports.default = main;
